﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Hotline.Share.Dtos.JudicialManagement
{
    /// <summary>
    /// 左上工单数据模块
    /// </summary>
    public class OrderModuleDto
    {
        /// <summary>
        /// 行政执法工单
        /// </summary>
        public int EnforcementOrderNum { get; set; }

        /// <summary>
        /// 线索属实
        /// </summary>
        public int TheClueIsTrueNum { get; set; }

        /// <summary>
        /// 线索不属实
        /// </summary>
        public int TheClueIsNotTrueNum { get; set; }

        /// <summary>
        /// 推诿工单
        /// </summary>
        public int PassTheBuckOrderNum { get; set; }

        /// <summary>
        /// 满意工单
        /// </summary>
        public int SatisfiedCount { get; set; }

        /// <summary>
        /// 工单总量
        /// </summary>
        public int OrderCountNum { get; set; }


    }

    /// <summary>
    /// 左中受理类型
    /// </summary>
    public class OrderAcceptTypeStatisticsDto
    {
        /// <summary>
        /// 类型名称
        /// </summary>
        public string AcceptType { get; set; }

        /// <summary>
        /// 总量
        /// </summary>
        public int SumCount { get; set; }

        /// <summary>
        /// 在办
        /// </summary>
        public int HandlingCount { get; set; }

        /// <summary>
        /// 已办
        /// </summary>
        public int FiledCount { get; set; }

        /// <summary>
        /// 超期
        /// </summary>
        public int OverTimeCount { get; set; }
    }

    /// <summary>
    /// 左下高频事项统计
    /// </summary>
    public class OrderEventTypeStatisticsDto
    {
        /// <summary>
        /// id
        /// </summary>
        public string EventTypeId { get; set; }

        /// <summary>
        /// 名称
        /// </summary>
        public string EventTypeName { get; set; }

        /// <summary>
        /// 总量
        /// </summary>
        public int SumCount { get; set; }
    }

    /// <summary>
    /// 中上区域数据统计
    /// </summary>
    public class OrderAreaQueryDto
    {
        /// <summary>
        /// 区域Id
        /// </summary>
        public string AreaCode { get; set; }

        /// <summary>
        /// 区域名称
        /// </summary>
        public string AreaName { get; set; }

        /// <summary>
        /// 行政执法工单
        /// </summary>
        public int EnforcementOrderNum { get; set; }

        /// <summary>
        /// 线索属实
        /// </summary>
        public int TheClueIsTrueNum { get; set; }

        /// <summary>
        /// 线索不属实
        /// </summary>
        public int TheClueIsNotTrueNum { get; set; }

        /// <summary>
        /// 推诿工单
        /// </summary>
        public int PassTheBuckOrderNum { get; set; }

        /// <summary>
        /// 工单总量
        /// </summary>
        public int OrderCountNum { get; set; }
    }

    /// <summary>
    /// 右上满意度排行榜
    /// </summary>
    public class OrderVisitOrgStatisticsDto
    {
        /// <summary>
        /// 部门Code
        /// </summary>
        public string VisitOrgCode { get; set; }

        /// <summary>
        /// 部门名称
        /// </summary>
        public string VisitOrgName { get; set; }

        /// <summary>
        /// 满意量
        /// </summary>
        public int SatisfiedCount { get; set; }

        /// <summary>
        /// 总量
        /// </summary>
        public int VisitCount { get; set; }

        /// <summary>
        /// 满意率
        /// </summary>
        public double SatisfiedRate => CalcSatisfiedRate();

        public double CalcSatisfiedRate()
        {
            if (SatisfiedCount == 0 || VisitCount == 0)
            {
                return 0;
            }
            return Math.Round((SatisfiedCount / (double)VisitCount) * 100, 2);
        }
    }
}
